package xyz.lychee.lagfixer.libs.adventure.bossbar;

import java.util.Collections;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.Internal;

@Internal
public interface BossBarImplementation {
   @Internal
   static <I extends BossBarImplementation> @NotNull I get(final @NotNull BossBar bar, final @NotNull Class<I> type) {
      return BossBarImpl.ImplementationAccessor.get(bar, type);
   }

   @Internal
   default @NotNull Iterable<? extends BossBarViewer> viewers() {
      return Collections.emptyList();
   }

   @Internal
   public interface Provider {
      @Internal
      @NotNull BossBarImplementation create(final @NotNull BossBar bar);
   }
}
